<?php
/*------------------------------------------------------------------------
# Copyright (C) 2015-2016 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 *Ark Typography Ajax Plugin
 *
 * @package     Joomla.Plugin
 * @subpackage  Ajax.imageUpload
 */

error_reporting(E_ERROR & ~E_NOTICE);
  
if (version_compare(JVERSION, '4.0', 'lt' ) )
{  
    require_once JPATH_ADMINISTRATOR.'/components/com_media/helpers/media.php';
} 
 
class PlgAjaxArkImageUpload extends JPlugin
{
	
    public function onAjaxArkimageupload()
	{

		//load media manager language 
		
		$lang = JFactory::getLanguage();
		$lang->load('com_media', JPATH_ADMINISTRATOR, null, false, true)
		||	$lang->load('com_media', JPATH_SITE, null, false, true);

		
		$params = JComponentHelper::getParams('com_arkeditor');
		
		$useUserFolder 	=  $params->get('enable_userfolders',1);
		$userFolderType =  $params->get('userfoldertype','username');
		
		$mediaBase = JPATH_ROOT . '/' .$params->get('imagePath', 'images');
		$mediaBaseURL = $params->get('imagePath', 'images');
		
		if($useUserFolder)
		{	
			//Get user
			$user = JFactory::getUser();
			//Joomla does not have a function to determine if a user belonging
			//to a group is in this set.  As a result we have to do the work
			//ourselves.
			
			
			$groups			= $user->getAuthorisedGroups();
			$restirectTo 	= $params->get( 'displayFoldersTo', false );


			$groups = array_values($groups);
	 
			$skip = false;
	 
			if($user->get('isRoot'))
				$skip = true;
			
			//check to see if user is root user if so skip
						
			if(!$skip && $groups && $restirectTo )
			{
				for( $n=0, $i=count($groups); $n<$i; $n++ )
				{
					if( in_array( $groups[$n], $restirectTo ) )
					{
						//Seems this user is able to view all folders.
						$skip = true;
						break;
					}//end if
				}//end for loop
			}//end if
			
			if(!$skip)
			{	
				if($userFolderType == 'username')
				{
					$id =  $user->username;
				}	
				else
				{ 	
					$id  = $user->id;	
				}

				$mediaBase .= '/users/'.$id;
				$mediaBaseURL .= '/users/'.$id;
			}
		}
		
		define('COM_MEDIA_BASE',    $mediaBase);
		define('COM_MEDIA_BASEURL', $mediaBaseURL);
						
		$input = JFactory::getApplication()->input;
	
		$input->set('task','file.upload');
		$input->set('format','json');
        $input->set('ARKInline',true);
		$input->set('folder','');
				
		ob_start();
		
		$controller	= JControllerLegacy::getInstance('Media', array('base_path' =>JPATH_ADMINISTRATOR.'/components/com_media'));
		
		$controller->execute($input->get('task'));
		
		$results = trim(ob_get_contents());
		
		ob_end_clean();
		
		$response = json_decode($results,true); 
	
		$output = array();
		
		if($response['status'])
		{
			$file  = $input->files->get('Filedata', '', 'array');
     		$name =  ltrim($response['location'],'/'); 
            $output['uploaded'] = 1;
			$output['fileName'] =  array_pop(explode('/',$name));
			$output['url'] = $name;
		}
		else
		{
			$output['uploaded'] = 0;
		
			$error = $response['error'];
			if(!$error)
			{
				$messageQueue = JFactory::getApplication()->getMessageQueue();
				if(count($messageQueue))
				{	
					$error = array_pop($messageQueue);
				}	
			}
			if(is_array($error) && isset($error['message']))
				$output['error'] = array('message'=>$error['message']);
			else
				$output['error'] = array('message'=>$error);
		}
		
		//output json response
		echo json_encode($output);
		exit();
	}	
}