<?php
/*------------------------------------------------------------------------
# Copyright (C) 2015-2016 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 


defined('_JEXEC') or die;


use Joomla\CMS\Factory;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\Registry\Registry;
use Joomla\CMS\Plugin\PluginHelper;
//use Joomla\Component\Media\Administrator\Controller\ApiController;
/**
 *Ark Typography Ajax Plugin
 *
 * @package     Joomla.Plugin
 * @subpackage  Ajax.fileupload
 */

error_reporting(E_ERROR & ~E_NOTICE);
  
 
class PlgAjaxArkUpload extends CMSPlugin
{
	
    public function onAjaxArkupload()
	{

		//load media manager language 
		
		$lang = \JFactory::getLanguage();
		$lang->load('com_media', JPATH_ADMINISTRATOR, null, false, true)
		||	$lang->load('com_media', JPATH_SITE, null, false, true);

		
		$params = \JComponentHelper::getParams('com_arkeditor');
		
		$useUserFolder 	=  $params->get('enable_userfolders',1);
		$userFolderType =  $params->get('userfoldertype','username');
		
		$filePath = $params->get('filePath', 'files');
		$imagePath = $params->get('imagePath', 'images');

		
		if($useUserFolder)
		{	
			//Get user
			$user = \JFactory::getUser();
			//Joomla does not have a function to determine if a user belonging
			//to a group is in this set.  As a result we have to do the work
			//ourselves.
			
			
			$groups			= $user->getAuthorisedGroups();
			$restirectTo 	= $params->get( 'displayFoldersTo', false );


			$groups = \array_values($groups);
	 
			$skip = false;
	 
			if($user->get('isRoot'))
				$skip = true;
			
			//check to see if user is root user if so skip
						
			if(!$skip && $groups && $restirectTo )
			{
				for( $n=0, $i= count($groups); $n<$i; $n++ )
				{
					if( \in_array( $groups[$n], $restirectTo ) )
					{
						//Seems this user is able to view all folders.
						$skip = true;
						break;
					}//end if
				}//end for loop
			}//end if
			
			if(!$skip)
			{	
				if($userFolderType == 'username')
				{
					$id =  $user->username;
				}	
				else
				{ 	
					$id  = $user->id;	
				}

				$filePath .= '/users/'.$id;
				$imagePath .= '/users/'.$id;
			}
		}
		

		$app = 	Factory::getApplication();			
		$input = $app->input;

		$plugin = PluginHelper::getPlugin('filesystem','local');
	
	     if($input->getString('filetype') == 'image')
		 {			 
			if (!$plugin->params instanceof Registry)
			{
				$plugin->params  = new Registry($plugin->params );
			}
			
			$plugin->params->get('directories', '[{"directory": "'.$imagePath.'"}]');
			
			$input->set('path',	'local-images:/');
		 }	
		elseif($input->getString('filetype') == 'file')
		{
			if (!$plugin->params instanceof Registry)
			{
				$plugin->params  = new Registry($plugin->params );
			}
			
			$plugin->params->get('directories', '[{"directory": "'.$filePath.'"}]');
		
			$input->set('path',	'ark-files:/');
			$input->set('mediatypes',	'3');
		}	
		else
		{	
			$input->set('path','');
		}	
		$input->set('task','files');
        $input->set('ARKInline',true);
		$input->json->set('override',true);
				
        $filetype =  $input->getString('filetype');
		
		function closeAppHandler($filetype, $imagePath, $filePath) {

			
			$results = trim(ob_get_contents());
			ob_end_clean();
	 
			$response = json_decode($results,true); 
		
			$output = [];
			
			if($response['success'])
			{
				$data = (array) $response['data'];
				
				$pathInfo = explode(':', $data['path'], 2);

				$name =  ltrim($data['name'],'/'); 
		
				$output['uploaded'] = 1;
				$output['fileName'] =  $data['name'];
				$base = $filetype == 'image' ? $imagePath : $filePath;
				
				$output['url'] = $base.$pathInfo[1];
			}
			else
			{
				$output['uploaded'] = 0;
			
				$error = $response['message'];
				if(!$error)
				{
					$messageQueue = JFactory::getApplication()->getMessageQueue();
					if(count($messageQueue))
					{	
						$error = array_pop($messageQueue);
					}	
				}
				if(is_array($error) && isset($error['message']))
					$output['error'] = array('message'=>$error['message']);
				else
					$output['error'] = array('message'=>$error);
			}
			
			//output json response
			echo json_encode($output);
			exit;
		};
		
		register_shutdown_function('closeAppHandler', $filetype, $imagePath, $filePath);
		
		ob_start();
			
		$controller = $app->bootComponent('com_media')
			->getMVCFactory()->createController('Api', 'Administrator', [], $app, $input);
		
		$controller->execute($input->get('task'));

		
	
	}	
}