<?php
/*------------------------------------------------------------------------
# Copyright (C) 2022 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 *Ark inline content  System Plugin
 *
 * @package     Joomla.Plugin
 * @subpackage  ArkEvents.Format
 */

class PlgArKEventsToolbarLanguage extends JPlugin
{
	
	protected $db;
	
	
	public function onInstanceCreated(&$params)
	{
		
		
		$lang_mode						= 	$params->def( 'lang_mode', 1 );
		$lang							= 	$params->def( 'lang_code', 'en' );
		
		
		
		$language  = JFactory::getLanguage();
		
		if ($language->isRTL()) {
			$direction = 'rtl';
		} else {
			 $direction = 'ltr';
		}
		
		$lang = strtolower($language->getTag());
		
		$lang =  ($lang == 'en-gb' ? 'en' : $lang  );
		
		switch ($lang_mode)
		{
		 case 0:
		    if(!in_array($lang, array('ar', 'dv', 'fa', 'ha', 'he', 'ks', 'ku', 'ps', 'ur', 'yi')))
			{	
				$direction = 'ltr';	
			}	
			break;
		 case 1:
			// Joomla Default
			//Access Joomla's global configuation and get the language setting from there
			if (file_exists(JPATH_PLUGINS . "/editors/arkeditor/ckeditor/lang/" . $lang . ".js"))
			{
				//Do Nothing
			}
			elseif (file_exists(JPATH_PLUGINS . "/editors/arkeditor/ckeditor/lang/" . substr($lang, 0, strpos($lang, '-')) . ".js"))
			{
				$lang = substr($lang, 0, strpos($lang, '-'));
			} 
			break;
		 case 2:
			$lang = ""; // Browser default
			$direction = '';
			break; 
		}
				
		//set lang param for later use
		$params->set('lang', $lang);
		
		//set Langugae direction for later use
		$params->set('direction', $direction);

		if($lang && $lang != 'en')
		{

			if($lang && file_exists(JPATH_PLUGINS . "/editors/arkeditor/ckeditor/lang/" . $lang . ".js"))
			{			
		
					
				return	"editor.on( 'configLoaded', function() {					
							CKEDITOR.lang.languages['".$lang."'] = 1; 
						});";	

			}
		
		}
	
		return '';	
	}
}